# Example of summing all the values in a data stream
import rx
from rx import operators as op

# Set up a source
observable = rx.from_list([2, 3, 5, 7])
# Apply target_sum function to initial source
observable2 = observable.pipe(
    op.sum()
)
# Subscribe to the result generated by target_sum
observable2.subscribe(lambda v: print(v))

print('-' * 20)

# Rolling or incremental target_sum
rx.from_([2, 3, 5, 7]).pipe(
          op.scan(lambda subtotal, i: subtotal+i)
).subscribe(lambda v: print(v))